/* DYNAMIC SC DENSE CODE. count-bytes version -- 
A dynamic word-based byte oriented compressor for text files based on 
(s,c)-Dense Code.

Programmed by Antonio Faria
Copyright (C) 2006  Nieves R. Brisaboa, Gonzalo Navarro, Antonio Faria and Jos R. Param
Author's contact: antonio.fari@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*-----------------------------------------------------------------------
 File    : compressor
 Function  : Main file of the compressor
 ------------------------------------------------------------------------*/

#include <string.h>
#include <stdlib.h>
#include <math.h>

#include <malloc.h>
#include <stdio.h>


#include "constants.h"
#include "valstring.h"


#include "BufferedReader.h"
#include "timer.h"
#include "hash.h"
#include "BufferedWriter.h"
#include "compatibility.h"
#define B_value 256


//const unsigned long BASE[4] = {1,256,65536,16777216};


   unsigned long S_value;
   unsigned long C_value;

	//Structure used for stimating the optimal S_value
	  //long T[3];   //Compressed text size when using s = s0 = S_value -1;

	  unsigned long TCs0;   //Compressed text size when using s = s0 = S_value -1;
	  unsigned long TCs1;   //Compressed text size when using s = s1 = S_value ;
	  unsigned long TCs2;	//Compressed text size when using s = s2 = S_value +1;

/************/

	unsigned long *positionInTH;

	unsigned long *topBlock;  /* holds a the first word of each frequency */
	unsigned long zeroNode;	  /* zeroNode is the place where a new word will be inserted */
	unsigned long MAXFREQ;	  /* Maximum frequency of a word currently reached */

	unsigned long K;		  /* size of the codeword obtained by getCode */
	unsigned long CODEWORD;	  /* Codeword obtained by getCode */



	//variables used in the "full process"
	unsigned long j;	 	 //stores the position in the vocabulary of the current parsed word
	//	unsigned long nj;        //next j
    unsigned long addrInTH;
	unsigned long zeroNode;		   /* zeroNode is the place where a new word will be inserted */



	//functions used.
	void initialize (unsigned long tamArq, unsigned long tamTop);
	void getCode(register unsigned long position);
	unsigned long fileSize (char *filename); 
	void mainCompressor (char* infile, char* outfile, unsigned long N_val, unsigned long N_val2);

//	void initialize (unsigned long tamArq, unsigned long tamTop);
//	void getCode(register unsigned long position);
//	void mainCompressor (char* infile, char* outfile, unsigned long N_val, unsigned long N_val2);
//
//
